!
!     module m_intersection_data_14
!
      module m_intersection_data_14
!
!      Written by H. Matsui on june, 2006
!
      use m_precision
!
      implicit none
!
!
!   4 nodes which have differrent sign connected 3 edges
!      (one hexagonal ... 4 triangles)
!
!     flag = 1: c-c_ref >= 0
!     flag = 1: c-c_ref < 0
!
!        12345678: boundary...6 of 12: hexagonal
!                    (3-1-2), (4-1-3), (4-6-1), (4-5-6)
!    23: 11101000: 8-5, 4-1, 3-4, 3-7, 2-6, 5-6: 8-4-3-11-10-5
!                    3-8-4, 11-8-3, 11-5-8, 11-10-5
!    46: 01110100: 5-6, 1-2, 4-1, 4-8, 3-7, 6-7: 5-1-4-12-11-6
!                    4-5-1, 12-5-4, 12-6-5, 12-11-6
!    77: 10110010: 6-7, 2-3, 1-2, 1-5, 4-8, 7-8: 6-2-1- 9-12-7
!                    1-6-2,  9-6-1,  9-7-6,  9-12-7
!   139: 11010001: 7-8, 3-4, 2-3, 2-6, 1-5, 8-5: 7-3-2-10- 9-8
!                    2-7-3, 10-7-2, 10-8-7, 10- 9-8

!   232: 00010111: 4-1, 8-5, 5-6, 2-6, 3-7, 3-4: 4-8-5-10-11-3
!                    5-4-8, 10-4-5, 10-3-4, 10-11-3
!   209: 10001011: 1-2, 5-6, 6-7, 3-7, 4-8, 4-1: 1-5-6-11-12-4
!                    6-1-5, 11-1-6, 11-4-1, 11-12-4
!   178: 01001101: 2-3, 6-7, 7-8, 4-8, 1-5, 1-2: 2-6-7-12- 9-1
!                    7-2-6, 12-2-7, 12-1-2, 12- 9-1
!   116: 00101110: 3-4, 7-8, 8-5, 1-5, 2-6, 2-3: 3-7-8- 9-10-2
!                    8-3-7,  9-3-8,  9-2-3,  9-10-2

!    99: 11000110: 4-1, 2-3, 3-7, 7-8, 5-6, 1-5: 4-2-11-7-5- 9
!                    11-4-2, 7-4-11, 7- 9-4, 7-5- 9
!   198: 01100011: 1-2, 3-4, 4-8, 8-5, 6-7, 2-6: 1-3-12-8-6-10
!                    12-1-3, 8-1-12, 8-10-1, 8-6-10
!   156: 00111001: 2-3, 4-1, 1-5, 5-6, 7-8, 3-7: 2-4- 9-5-7-11
!                     9-2-4, 5-2- 9, 5-11-2, 5-7-11
!    57: 10011100: 3-4, 1-2, 2-6, 6-7, 8-5, 4-8: 3-1-10-6-8-12
!                    10-3-1, 6-3-10, 6-12-3, 6-8-12
!
!
      integer(kind = kint), parameter, private :: nnod_tri = 3
      integer(kind = kint), parameter, private :: nnod_hex = 6
!
      integer(kind = kint), parameter :: nkind_etype_14 = 12
      integer(kind = kint), parameter :: num_patch_14 =   4
      integer(kind = kint), parameter :: itri_2_patch_14(12)            &
     &     = (/3, 1, 2,   4, 1, 3,   4, 6, 1,   4, 5, 6/)
!
      integer(kind = kint), parameter                                   &
     &   :: iflag_psf_etype_14(nkind_etype_14)                          &
     &     = (/ 23,  46,  77, 139,    232, 209, 178, 116,               &
     &          99, 198, 156, 57/)
!
      integer(kind = kint), parameter                                   &
     &        :: iedge_hex_14(nnod_hex,nkind_etype_14)                  &
     &      = reshape(                                                  &
     &       (/ 8, 4,  3, 11, 10,  5,    5, 1,  4, 12, 11,  6,          &
     &          6, 2,  1,  9, 12,  7,    7, 3,  2, 10,  9,  8,          &
     &          4, 8,  5, 10, 11,  3,    1, 5,  6, 11, 12,  4,          &
     &          2, 6,  7, 12,  9,  1,    3, 7,  8,  9, 10,  2,          &
     &          4, 2, 11,  7,  5,  9,    1, 3, 12,  8,  6, 10,          &
     &          2, 4,  9,  5,  7, 11,    3, 1, 10,  6,  8, 12/),        &
     &       shape=(/nnod_hex,nkind_etype_14/) )
!
      integer(kind = kint), parameter                                   &
     &        :: iedge_4_patch_14(nnod_tri,num_patch_14,nkind_etype_14) &
     &      = reshape(                                                  &
     &       (/ 3, 8, 4,   11, 8,  3,   11,  5, 8,   11, 10,  5,        &
     &          4, 5, 1,   12, 5,  4,   12,  6, 5,   12, 11,  6,        &
     &          1, 6, 2,    9, 6,  1,    9,  7, 6,    9, 12,  7,        &
     &          2, 7, 3,   10, 7,  2,   10,  8, 7,   10,  9,  8,        &
     &          5, 4, 8,   10, 4,  5,   10,  3, 4,   10, 11,  3,        &
     &          6, 1, 5,   11, 1,  6,   11,  4, 1,   11, 12,  4,        &
     &          7, 2, 6,   12, 2,  7,   12,  1, 2,   12,  9,  1,        &
     &          8, 3, 7,    9, 3,  8,    9,  2, 3,    9, 10,  2,        &
     &         11, 4, 2,    7, 4, 11,    7,  9, 4,    7,  5,  9,        &
     &         12, 1, 3,    8, 1, 12,    8, 10, 1,    8,  6, 10,        &
     &          9, 2, 4,    5, 2,  9,    5, 11, 2,    5,  7, 11,        &
     &         10, 3, 1,    6, 3, 10,    6, 12, 3,    6,  8, 12/),      &
     &       shape=(/nnod_tri,num_patch_14,nkind_etype_14/) )
!
!
      end module m_intersection_data_14
